// TestC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include "DigitSign.h"
#include <time.h>



int _tmain(int argc, _TCHAR* argv[])
{
	QDIGITSIGN_CTX ctx;
	VERIFY_RESULT verifyResult;
	int ret;

	ret = qdigitsign_set(QDIGITSIGN_OPT_OID_MAP_FILE, "OID.txt");
	ret = qdigitsign_set(QDIGITSIGN_OPT_CONFIG_FILE, "config.conf");

	ret = qdigitsign_set(QDIGITSIGN_OPT_LOG_FILE, "log.log");
	ret = qdigitsign_set(QDIGITSIGN_OPT_LOG_LEVEL, (void*)LOG_TYPE_DEBUG);

	ret = qdigitsign_set(QDIGITSIGN_OPT_CACERT_DIR, "C:\\Progetti\\Cryptware\\elencopubblico\\elencopubblico");

	ctx = qdigitsign_sign_init();

	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_PKCS11, "bit4ipki");
	
	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_CADES, (void*)1);

	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_PIN, "12345678");

	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_ALIAS, "AUTHCertificate0");

	
	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_TSA_URL, "http://tsa.safecreative.org");

	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_INPUTFILE, "test.txt");

	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_OUTPUTFILE, "test.txt.p7m");


	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_INPUTFILE_TYPE, QDIGITSIGN_FILETYPE_AUTO);

	ret = qdigitsign_sign_set(ctx, QDIGITSIGN_OPT_VERIFY_REVOCATION, 0);

	ret = qdigitsign_sign_sign(ctx);

	qdigitsign_sign_cleanup(ctx);

	
	// VERIFY

	ctx = qdigitsign_verify_init();

	ret = qdigitsign_verify_set(ctx, QDIGITSIGN_OPT_INPUTFILE, "test.txt.p7m");
	
	ret = qdigitsign_verify_set(ctx, QDIGITSIGN_OPT_INPUTFILE_TYPE, (void*)QDIGITSIGN_FILETYPE_P7M);

	ret = qdigitsign_verify_set(ctx, QDIGITSIGN_OPT_VERIFY_REVOCATION, 1);

	ret = qdigitsign_verify_verify(ctx, &verifyResult);

	ret = qdigitsign_verify_cleanup_result(&verifyResult);

	ret = qdigitsign_verify_cleanup(ctx);

	return 0;
}

