package test.jqdigitsign;

import com.cryptware.jqdigitsign;

/**
 * Esempio d'uso di JQDigitSign
 *
 * @author ugo chirico
 */
public class QDigitSign {

    public static void main(String[] args)
    {
    	long nRet = QDigitSign.setOption(QDigitSign.QDIGITSIGN_OPT_OID_MAP_FILE, "OID.txt");
        if (nRet != 0)
        {
            System.out.println("errore OID: " + nRet);
        }

        //QDigitSign.setOption(QDigitSign.QDIGITSIGN_OPT_LICENSEE, "xxx");
        //QDigitSign.setOption(QDigitSign.QDIGITSIGN_OPT_PRODUCTKEY, "yyy");

        QDigitSign.setOption(QDigitSign.QDIGITSIGN_OPT_LOG_FILE, "log.log");

        QDigitSign.setOption(QDigitSign.QDIGITSIGN_OPT_LOG_LEVEL, QDigitSign.LOG_TYPE_DEBUG);

        Signer signer = QDigitSign.getSigner();

        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PKCS11, "bit4ipki");
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_CADES, 1);
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PIN, "12345678");

		// Select a certificate by label
		//signer.setOption(QDigitSign.QDIGITSIGN_OPT_ALIAS, "<certificate label>");

		// TSA
        //signer.SetOption(QDigitSign.QDIGITSIGN_OPT_TSA_URL, "<url>");
        //signer.SetOption(QDigitSign.QDIGITSIGN_OPT_TSA_USERNAME, "<username>");
        //signer.SetOption(QDigitSign.QDIGITSIGN_OPT_TSA_PASSWORD, "<password>");

        signer.setOption(QDigitSign.QDIGITSIGN_OPT_INPUTFILE, "test.pdf");
        ret = digitsign_sign_setopt(ctx, QDIGITSIGN_OPT_OUTPUTFILE, "test.signed.pdf");

        signer.setOption(QDigitSign.QDIGITSIGN_OPT_INPUTFILE_TYPE, QDigitSign.QDIGITSIGN_FILETYPE_AUTO);
        //ret = digitsign_sign_setopt(ctx, QDIGITSIGN_OPT_INPUTFILE_TYPE, QDIGITSIGN_FILETYPE_PDF);

        signer.setOption(QDigitSign.QDIGITSIGN_OPT_VERIFY_REVOCATION, 0);

        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_BOTTOM, 100);
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_LEFT, 100);
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_WIDTH, 300);
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_HEIGHT, 300);
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_NAME, "Ugo Chirico");
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_NAME_LABEL, "Signed By:");
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_REASON_LABEL, "Reason:");
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_REASON, "Signature");
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_LOCATION_LABEL, "Location:");
        signer.setOption(QDigitSign.QDIGITSIGN_OPT_PDF_LOCATION, "Naples");

        //signer.SetOption(QDigitSign.QDIGITSIGN_OPT_PDF_IMAGEPATH, "1303876972216.jpg");

        nRet = signer.sign();
        if (nRet != 0)
        {
            System.out.println("errore nella firma digitale: " + nRet);
        }

        signer.cleanup();

		// verification
        Verifier verifier = QDigitSign.getVerifier();

        verifier.setOption(QDigitSign.QDIGITSIGN_OPT_INPUTFILE, "test.signed.pdf");
        //verifier.SetOption(QDigitSign.QDIGITSIGN_OPT_VERIFY_REVOCATION, true);

        StringBuilder xmlRet = new StringBuilder();
        nRet = verifier.verify(xmlRet);
        if (nRet != 0)
        {
            System.out.println("errore nella verifica della firma digitale: " + nRet);
        }

        QDigitSign.cleanup();
    }
}
