﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cryptware.QDigitSign;
using System.Runtime.InteropServices;

namespace TestQDigitSignNet
{
    class Program
    {
        static void Main(string[] args)
        {
            long nRet;

            QDigitSign qDigitSign = new QDigitSign();

            nRet = qDigitSign.SetStringOption(QDigitSign.QDIGITSIGN_OPT_OID_MAP_FILE, "OID.txt");
            if (nRet != 0)
            {
                Console.WriteLine("errore OID: " + nRet);
            }

            qDigitSign.SetStringOption(QDigitSign.QDIGITSIGN_OPT_LOG_FILE, "log.log");
	
	        qDigitSign.SetIntOption(QDigitSign.QDIGITSIGN_OPT_LOG_LEVEL, QDigitSign.LOG_TYPE_DEBUG);
            
            Signer signer = qDigitSign.Signer;

            signer.SetStringOption(QDigitSign.QDIGITSIGN_OPT_PKCS11, "bit4ipki");

            signer.SetIntOption(QDigitSign.QDIGITSIGN_OPT_CADES, 1);

            signer.SetStringOption(QDigitSign.QDIGITSIGN_OPT_PIN, "12345678");

            signer.SetStringOption(QDigitSign.QDIGITSIGN_OPT_ALIAS, "AUTHCertificate0");
            
            signer.SetStringOption(QDigitSign.QDIGITSIGN_OPT_INPUTFILE, "test.txt");
       
			signer.SetIntOption(QDigitSign.QDIGITSIGN_OPT_INPUTFILE_TYPE, QDigitSign.QDIGITSIGN_FILETYPE_AUTO);

            signer.SetIntOption(QDigitSign.QDIGITSIGN_OPT_VERIFY_REVOCATION, 0);
            
            nRet = signer.Sign();
            if (nRet != 0)
            {
                Console.WriteLine("errore nella firma digitale: " + nRet);
            }

            signer.Cleanup();
            
            Verifier verifier = qDigitSign.Verifier;

            verifier.SetStringOption(QDigitSign.QDIGITSIGN_OPT_INPUTFILE, "test.txt.p7m");
            verifier.SetBoolOption(QDigitSign.QDIGITSIGN_OPT_VERIFY_REVOCATION, true);

            VerifyResult verifyResult = verifier.Verify();
            if (verifyResult.errorCode != 0)
            {
                Console.WriteLine("errore nella firma digitale: " + verifyResult.errorCode);
            }

            verifier.CleanupResult(verifyResult);
            qDigitSign.Cleanup();
        }
    }
}
